#include "string.h"
#include<Servo.h>
#define Cont_threshold 7
#define thgain 1
#define thgain2 1

char recieve_data[80];//受信可能文字数
char cmpstr[10];//チェック用文字列格納用
int chkstr[17];//17入力 (X,Y,Z,rZ,B1~~~B12,POV)
int recieve_cont = 0;//文字カウント用変数
int vector0;
int vector1;
int vector2;
int vector3; 
bool recieve_end = false;//命令が更新されているか（文字列の終端まで到達しているか）

Servo servo1;

void setup() {
  // put your setup code here, to run once:
  //pinMode(A1,OUTPUT);//11PINはLED
 servo1.attach(4);
 
  pinMode(A1,OUTPUT);//Motor2
  pinMode(A2,OUTPUT);//Motor3
  pinMode(A3,OUTPUT);//Motor4
  pinMode(A4,OUTPUT);//Motor5
 
  pinMode(10,OUTPUT);//Motor2
  pinMode(11,OUTPUT);//Motor3
  pinMode(13,OUTPUT);//Motor4
  pinMode(14,OUTPUT);//Motor5
  
  Serial1.begin(115200);//Arduinoに直接接続してテストする場合は，この行以降のSerial1をSerialに変更すること．

}

void loop() {
  
  // put your main code here, to run repeatedly:
 SerialRead();
  
  if(recieve_end){//命令が更新されているか？
    //動作する内容を変更する
    //コントローラから得られた数値から機体を動作させるための推力値に変換する
    //17項目を読み込み，int型で格納
    //chkstr[0] = atoi(strtok(recieve_data,","));//命令セット文字列を格納
    //for(int sep = 1;sep < 17;sep++)chkstr[sep] = atoi(strtok(NULL,","));
  
    if (chkstr[1] > Cont_threshold) {//Y軸上＋
        vector1 = (int)((chkstr[1] * thgain2));
        vector2 = (int)((chkstr[1] * thgain2));
    }
    if (chkstr[1] < -Cont_threshold) {//Y軸上－
        vector1 = (int)((chkstr[1] * thgain2));
        vector2 = (int)((chkstr[1] * thgain2));
    }
    if (chkstr[0] > Cont_threshold) {//X軸上＋
        vector1 = (int)(- chkstr[0] * thgain2);
        vector2 = (int)(chkstr[0] * thgain2);
    }
    if (-Cont_threshold > chkstr[0]) {//X軸上－
        vector1 = (int)(- chkstr[0] * thgain2);
        vector2 = (int)(chkstr[0] * thgain2);
    }
    
    if (((-Cont_threshold > chkstr[0]) && (-Cont_threshold > chkstr[1])) || ((-Cont_threshold > chkstr[0]) && (chkstr[1] > Cont_threshold) || ((Cont_threshold < chkstr[0]) && (chkstr[1] > Cont_threshold)) || ((Cont_threshold < chkstr[0]) && (chkstr[1] < -Cont_threshold)))) {
        vector1 = (int)(((-1 * chkstr[0] * thgain2) + (-1 * chkstr[1] * thgain2)) / 2);
        vector2 = (int)(((chkstr[0] * thgain2) + (-1 * chkstr[1] * thgain2)) / 2);
    }

    if (((-Cont_threshold < chkstr[0]) && (chkstr[0] < Cont_threshold)) && ((chkstr[1] < Cont_threshold) && (-Cont_threshold < chkstr[1]))) {//原点範囲内
        vector1 = 0;
        vector2 = 0;
    }

    vector3 = chkstr[2];

    //限界値を超えた場合は足切り
    if (vector1 < -255) vector1 = -255;
    if (vector2 < -255) vector2 = -255;
    if (vector1 > 255) vector1 = 255;
    if (vector2 > 255) vector2 = 255;
    if (vector3 > 160) vector3 = 160;
    if (vector3 < -160) vector3 = -160;
    
    //格納したデータを処理して出力
    MotorDrive(2,vector1);
    MotorDrive(3,vector2);
    servo1.write(vector3);
    
  }else{
  //必要な処理があれば追加
  }
  
}

//モータを回転させる関数
//接続されたモータ（1～4），回転数(-254～254)で指定する
void MotorDrive(char motornom,int motorspeed){
  switch(motornom){
    case 2:
      if(motorspeed <= 0){
        digitalWrite(A1,LOW);
        digitalWrite(A2,HIGH);
        analogWrite(5,(-1) * motorspeed);
      }else{
        digitalWrite(A1,HIGH);
        digitalWrite(A2,LOW);
        analogWrite(5,motorspeed);
      }
      break;
    case 3:
      if(motorspeed <= 0){
        digitalWrite(A3,LOW);
        digitalWrite(A4,HIGH);
        analogWrite(6,(-1) * motorspeed);
      }else{
        digitalWrite(A3,HIGH);
        digitalWrite(A4,LOW);
        analogWrite(6, motorspeed);
      }
      break;
  }
}

//文字列を受信する関数
void SerialRead(){
  if(Serial1.available()){//Serialの受信があったか確認する
    recieve_data[recieve_cont] = Serial1.read();//受信した文字列を読み込む（1字/回）    
    if(recieve_cont > 50 || recieve_data[recieve_cont] == '\n'){//受信した文字数が50字or受信した文字が"\n”であるか？(\nとはC言語における文字列の改行文字)
      //下2行のコメントを外すと受信した文字列を[Recieve = "文字列"]という形で返信する
      //Serial1.write("Recieve = ");
      //Serial1.write(recieve_data);
      recieve_cont = 0;//文字列を入手したら文字数カウントを初期化する
      
      //文字列を切り取り，各値を確認する
      chkstr[0] = atoi(strtok(recieve_data,","));//命令セット文字列を格納
      for(int counter1 = 1;counter1 < 16;counter1++) chkstr[counter1] = atoi(strtok(NULL,","));//受け取る数値は右(a1,a2,a3,a4,p1,p2,p3,p4)
      memset(( void * )recieve_data ,NULL, sizeof(recieve_data));
      digitalWrite(11,LOW);//受信終了でLED消灯
      recieve_end = true;

    }else{//上の条件を満たさなかった場合は一文字ずらす．
      //Serial.write(recieve_data); //ここのコメントを外すと受信データを逐次送信する．
      digitalWrite(11,HIGH);//受信中はLED点灯
      recieve_cont++;
      recieve_end = true;
    }
  } 
}

